=== doc/CMakeLists.txt ===
install (FILES kcov.1 DESTINATION "${KCOV_INSTALL_MANDIR}/man1" )
