=== debian/changelog ===
kcov (43+dfsg-2) unstable; urgency=medium

  * Add a patch for GCC-15 (Closes: #1096917)
  * Add a patch for subshells
  * Add a patch to disable a test assertion
  * blhc: enable verbose builds and hardening flags
  * Update Standards-Version to 4.7.2

 -- William Desportes <williamdes@wdes.fr>  Thu, 11 Sep 2025 11:36:54 +0200

kcov (43+dfsg-1) unstable; urgency=medium

  * New upstream version 43+dfsg (Closes: #964654)
  * Update d/watch to v4
  * Update Maintainer and Standards-Version
  * Run tests after build
  * Refresh patches
  * Add "Rules-Requires-Root: no"
  * Add "Multi-Arch: no"
  * Update d/copyright
  * Move to pkgconf
  * Use debhelper-compat 13
  * Add DEP-8 tests
  * Install markdown docs

 -- William Desportes <williamdes@wdes.fr>  Mon, 29 Jul 2024 21:54:33 +0200
