=== debian/control ===
Source: kcov
Section: devel
Priority: optional
Maintainer: William Desportes <williamdes@wdes.fr>
Build-Depends: binutils-dev,
               cmake,
               debhelper-compat (= 13),
               libcurl4-openssl-dev,
               libdw-dev,
               libelf-dev,
               libiberty-dev,
               libjs-handlebars,
               libjs-jquery,
               libjs-jquery-tablesorter,
               libssl-dev,
               pkgconf,
               python-is-python3,
               python3,
               zlib1g-dev
Standards-Version: 4.7.2
Vcs-Git: https://salsa.debian.org/debian/kcov.git
Vcs-Browser: https://salsa.debian.org/debian/kcov
Homepage: https://simonkagstrom.github.io/kcov/
Rules-Requires-Root: no

Package: kcov
Architecture: any
Built-Using: ${misc:Built-Using}
Multi-Arch: no
Depends: python3, ${misc:Depends}, ${shlibs:Depends}
Description: Code coverage analysis using DWARF debugging information
 Kcov is a code coverage tester based on bcov by Thomas Neumann. It allows
 collecting code coverage information from executables without special
 command-line arguments, and continuosly produces output from long-running
 applications.
 .
 Kcov, like Bcov, uses DWARF debugging information to make this possible.
