=== debian/rules ===
#!/usr/bin/make -f

export DPKG_EXPORT_BUILDFLAGS = 1
export DEB_BUILD_HARDENING = 1
export DEB_BUILD_MAINT_OPTIONS := hardening=+all

# Extra hardening flags (D_FORTIFY_SOURCE, ...)
export DEB_CXXFLAGS_MAINT_APPEND = $(shell dpkg-buildflags --get CPPFLAGS)
export DEB_CFLAGS_MAINT_APPEND = $(shell dpkg-buildflags --get CPPFLAGS)

include /usr/share/dpkg/buildflags.mk

%:
	dh $@

override_dh_gencontrol:
	dh_gencontrol -- -Vmisc:Built-Using="$(shell dpkg-query -f '$${source:Package} (= $${source:Version})' -W binutils-dev)"

override_dh_auto_test:
	mkdir $(shell pwd)/build-tests

	cd $(shell pwd)/build-tests && \
		cmake .. -DCMAKE_SOURCE_DIR="$(shell pwd)/tests" \
			-DCMAKE_VERBOSE_MAKEFILE=ON

	cd $(shell pwd)/build-tests && VERBOSE=1 $(MAKE)

	PYTHONPYCACHEPREFIX="$(shell pwd)/py-cache" PYTHONPATH="$(shell pwd)/tests/tools" \
		python3 -m libkcov $(shell pwd)/obj-$(DEB_BUILD_GNU_TYPE)/src/kcov "$(shell pwd)/tests-temp" "$(shell pwd)/build-tests/" "." --no-ptrace -v

override_dh_auto_install:
	dh_auto_install
	# Policy: COPYING file is not needed
	find ./debian -type f -name "COPYING" -delete
	find ./debian -type f -name "COPYING.externals" -delete
