=== debian/tests/control ===
Tests: test.sh
Depends: @, @builddeps@

Tests: coverage-test.sh
Restrictions: superficial
Depends: jq, php-pear, @
