=== debian/watch ===
version=4
options="repacksuffix=+dfsg,repack,compression=xz,dversionmangle=s/\+dfsg//,filenamemangle=s%(?:.*?)?v?@ANY_VERSION@(@ARCHIVE_EXT@)%@PACKAGE@_$1+dfsg$2%" \
    https://github.com/SimonKagstrom/kcov/tags .*/v?(\d.*)@ARCHIVE_EXT@
